package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRDutySkill;
import cn.ibizlab.humanresource.core.humanresource.filter.HRDutySkillSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRDutySkill] 服务对象接口
 */
public interface IHRDutySkillService extends IService<HRDutySkill>{

    boolean create(HRDutySkill et) ;
    void createBatch(List<HRDutySkill> list) ;
    boolean update(HRDutySkill et) ;
    void updateBatch(List<HRDutySkill> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRDutySkill get(String key) ;
    HRDutySkill getDraft(HRDutySkill et) ;
    boolean checkKey(HRDutySkill et) ;
    boolean save(HRDutySkill et) ;
    void saveBatch(List<HRDutySkill> list) ;
    Page<HRDutySkill> searchDefault(HRDutySkillSearchContext context) ;
    List<HRDutySkill> selectByHrdutyid(String hrdutyid) ;
    void removeByHrdutyid(String hrdutyid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRDutySkill> getHrdutyskillByIds(List<String> ids) ;
    List<HRDutySkill> getHrdutyskillByEntities(List<HRDutySkill> entities) ;
}


